Index: /palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_advec.f90	(revision 1928)
+++ /palm/trunk/SOURCE/lpm_advec.f90	(revision 1929)
@@ -19,5 +19,11 @@
 ! Current revisions:
 ! ------------------
-!
+! Put stochastic equation in an extra subroutine.
+! Set flag for stochastic equation to communicate whether a particle is near 
+! topography. This case, memory and drift term are disabled in the Weil equation. 
+!
+! Enable vertical logarithmic interpolation also above topography. This case, 
+! set a lower limit for the friction velocity, as it can become very small 
+! in narrow street canyons, leading to too large particle speeds. 
 ! 
 ! Former revisions:
@@ -110,7 +116,6 @@
         ONLY:  block_offset, c_0, dt_min_part, grid_particles,                 &
                iran_part, log_z_z0, number_of_particles, number_of_sublayers,  &
-               particles, particle_groups, offset_ocean_nzt, sgs_wfu_part,     &
-               sgs_wfv_part, sgs_wfw_part, use_sgs_for_particles,              &
-               vertical_particle_advection, z0_av_global
+               particles, particle_groups, offset_ocean_nzt, sgs_wf_part,      &
+               use_sgs_for_particles, vertical_particle_advection, z0_av_global
         
     USE statistics,                                                            &
@@ -119,48 +124,51 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  agp                         !<
-    INTEGER(iwp) ::  gp_outside_of_building(1:8) !<
-    INTEGER(iwp) ::  i                           !<
-    INTEGER(iwp) ::  ip                          !<
-    INTEGER(iwp) ::  j                           !<
-    INTEGER(iwp) ::  jp                          !<
-    INTEGER(iwp) ::  k                           !<
-    INTEGER(iwp) ::  kp                          !<
-    INTEGER(iwp) ::  kw                          !<
-    INTEGER(iwp) ::  n                           !<
-    INTEGER(iwp) ::  nb                          !<
-    INTEGER(iwp) ::  num_gp                      !<
-
-    INTEGER(iwp), DIMENSION(0:7) ::  start_index !<
-    INTEGER(iwp), DIMENSION(0:7) ::  end_index   !<
-
-    REAL(wp) ::  aa                 !<
-    REAL(wp) ::  bb                 !<
-    REAL(wp) ::  cc                 !<
-    REAL(wp) ::  d_sum              !<
-    REAL(wp) ::  d_z_p_z0           !<
-    REAL(wp) ::  dd                 !<
-    REAL(wp) ::  de_dx_int_l        !<
-    REAL(wp) ::  de_dx_int_u        !<
-    REAL(wp) ::  de_dy_int_l        !<
-    REAL(wp) ::  de_dy_int_u        !<
-    REAL(wp) ::  de_dt              !<
-    REAL(wp) ::  de_dt_min          !<
-    REAL(wp) ::  de_dz_int_l        !<
-    REAL(wp) ::  de_dz_int_u        !<
+    INTEGER(iwp) ::  agp                         !< loop variable
+    INTEGER(iwp) ::  gp_outside_of_building(1:8) !< number of grid points used for particle interpolation in case of topography 
+    INTEGER(iwp) ::  i                           !< index variable along x
+    INTEGER(iwp) ::  ip                          !< index variable along x 
+    INTEGER(iwp) ::  ilog                        !< index variable along x 
+    INTEGER(iwp) ::  j                           !< index variable along y 
+    INTEGER(iwp) ::  jp                          !< index variable along y 
+    INTEGER(iwp) ::  jlog                        !< index variable along y 
+    INTEGER(iwp) ::  k                           !< index variable along z 
+    INTEGER(iwp) ::  kp                          !< index variable along z 
+    INTEGER(iwp) ::  kw                          !< index variable along z
+    INTEGER(iwp) ::  n                           !< loop variable over all particles in a grid box
+    INTEGER(iwp) ::  nb                          !< block number particles are sorted in
+    INTEGER(iwp) ::  num_gp                      !< number of adjacent grid points inside topography 
+
+    INTEGER(iwp), DIMENSION(0:7) ::  start_index !< start particle index for current block
+    INTEGER(iwp), DIMENSION(0:7) ::  end_index   !< start particle index for current block
+
+    REAL(wp) ::  aa                 !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  bb                 !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  cc                 !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  d_sum              !< dummy argument for horizontal particle interpolation in case of topography 
+    REAL(wp) ::  d_z_p_z0           !< inverse of interpolation length for logarithmic interpolation 
+    REAL(wp) ::  dd                 !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  de_dx_int_l        !< x/y-interpolated TKE gradient (x) at particle position at lower vertical level
+    REAL(wp) ::  de_dx_int_u        !< x/y-interpolated TKE gradient (x) at particle position at upper vertical level
+    REAL(wp) ::  de_dy_int_l        !< x/y-interpolated TKE gradient (y) at particle position at lower vertical level
+    REAL(wp) ::  de_dy_int_u        !< x/y-interpolated TKE gradient (y) at particle position at upper vertical level
+    REAL(wp) ::  de_dt              !< temporal derivative of TKE experienced by the particle
+    REAL(wp) ::  de_dt_min          !< lower level for temporal TKE derivative
+    REAL(wp) ::  de_dz_int_l        !< x/y-interpolated TKE gradient (z) at particle position at lower vertical level
+    REAL(wp) ::  de_dz_int_u        !< x/y-interpolated TKE gradient (z) at particle position at upper vertical level
     REAL(wp) ::  diameter           !< diamter of droplet
-    REAL(wp) ::  diss_int_l         !<
-    REAL(wp) ::  diss_int_u         !<
-    REAL(wp) ::  dt_gap             !<
-    REAL(wp) ::  dt_particle_m      !<
-    REAL(wp) ::  e_int_l            !<
-    REAL(wp) ::  e_int_u            !<
-    REAL(wp) ::  e_mean_int         !<
+    REAL(wp) ::  diss_int_l         !< x/y-interpolated dissipation at particle position at lower vertical level
+    REAL(wp) ::  diss_int_u         !< x/y-interpolated dissipation at particle position at upper vertical level
+    REAL(wp) ::  dt_gap             !< remaining time until particle time integration reaches LES time
+    REAL(wp) ::  dt_particle_m      !< previous particle time step
+    REAL(wp) ::  e_int_l            !< x/y-interpolated TKE at particle position at lower vertical level
+    REAL(wp) ::  e_int_u            !< x/y-interpolated TKE at particle position at upper vertical level
+    REAL(wp) ::  e_mean_int         !< horizontal mean TKE at particle height
     REAL(wp) ::  exp_arg            !<
     REAL(wp) ::  exp_term           !<
-    REAL(wp) ::  gg                 !<
-    REAL(wp) ::  height_p           !<
+    REAL(wp) ::  gg                 !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  height_p           !< dummy argument for logarithmic interpolation
     REAL(wp) ::  lagr_timescale     !< Lagrangian timescale
-    REAL(wp) ::  location(1:30,1:3) !<
+    REAL(wp) ::  location(1:30,1:3) !< wall locations
+    REAL(wp) ::  log_z_z0_int       !< logarithmus used for surface_layer interpolation
     REAL(wp) ::  random_gauss       !<
     REAL(wp) ::  RL                 !< Lagrangian autocorrelation coefficient
@@ -169,16 +177,16 @@
     REAL(wp) ::  rg3                !< Gaussian distributed random number
     REAL(wp) ::  sigma              !< velocity standard deviation
-    REAL(wp) ::  u_int_l            !<
-    REAL(wp) ::  u_int_u            !<
-    REAL(wp) ::  us_int             !<
-    REAL(wp) ::  v_int_l            !<
-    REAL(wp) ::  v_int_u            !<
+    REAL(wp) ::  u_int_l            !< x/y-interpolated u-component at particle position at lower vertical level
+    REAL(wp) ::  u_int_u            !< x/y-interpolated u-component at particle position at upper vertical level
+    REAL(wp) ::  us_int             !< friction velocity at particle grid box
+    REAL(wp) ::  v_int_l            !< x/y-interpolated v-component at particle position at lower vertical level
+    REAL(wp) ::  v_int_u            !< x/y-interpolated v-component at particle position at upper vertical level
     REAL(wp) ::  vv_int             !<
-    REAL(wp) ::  w_int_l            !<
-    REAL(wp) ::  w_int_u            !<
+    REAL(wp) ::  w_int_l            !< x/y-interpolated w-component at particle position at lower vertical level
+    REAL(wp) ::  w_int_u            !< x/y-interpolated w-component at particle position at upper vertical level
     REAL(wp) ::  w_s                !< terminal velocity of droplets
-    REAL(wp) ::  x                  !<
-    REAL(wp) ::  y                  !<
-    REAL(wp) ::  z_p                !<
+    REAL(wp) ::  x                  !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  y                  !< dummy argument for horizontal particle interpolation 
+    REAL(wp) ::  z_p                !< surface layer height (0.5 dz)
 
     REAL(wp), PARAMETER ::  a_rog = 9.65_wp      !< parameter for fall velocity
@@ -189,28 +197,28 @@
     REAL(wp), PARAMETER ::  d0_rog = 0.745_wp    !< separation diameter
 
-    REAL(wp), DIMENSION(1:30) ::  d_gp_pl !<
-    REAL(wp), DIMENSION(1:30) ::  de_dxi  !<
-    REAL(wp), DIMENSION(1:30) ::  de_dyi  !<
-    REAL(wp), DIMENSION(1:30) ::  de_dzi  !<
-    REAL(wp), DIMENSION(1:30) ::  dissi   !<
-    REAL(wp), DIMENSION(1:30) ::  ei      !<
-
+    REAL(wp), DIMENSION(1:30) ::  d_gp_pl !< dummy argument for particle interpolation scheme in case of topography
+    REAL(wp), DIMENSION(1:30) ::  de_dxi  !< horizontal TKE gradient along x at adjacent wall 
+    REAL(wp), DIMENSION(1:30) ::  de_dyi  !< horizontal TKE gradient along y at adjacent wall 
+    REAL(wp), DIMENSION(1:30) ::  de_dzi  !< horizontal TKE gradient along z at adjacent wall 
+    REAL(wp), DIMENSION(1:30) ::  dissi   !< dissipation at adjacent wall
+    REAL(wp), DIMENSION(1:30) ::  ei      !< TKE at adjacent wall
+
+    REAL(wp), DIMENSION(number_of_particles) ::  term_1_2     !< flag to communicate whether a particle is near topography or not
     REAL(wp), DIMENSION(number_of_particles) ::  dens_ratio   !<
-    REAL(wp), DIMENSION(number_of_particles) ::  de_dx_int    !<
-    REAL(wp), DIMENSION(number_of_particles) ::  de_dy_int    !<
-    REAL(wp), DIMENSION(number_of_particles) ::  de_dz_int    !<
-    REAL(wp), DIMENSION(number_of_particles) ::  diss_int     !<
-    REAL(wp), DIMENSION(number_of_particles) ::  dt_particle  !<
-    REAL(wp), DIMENSION(number_of_particles) ::  e_int        !<
-    REAL(wp), DIMENSION(number_of_particles) ::  fs_int       !<
-    REAL(wp), DIMENSION(number_of_particles) ::  log_z_z0_int !<
-    REAL(wp), DIMENSION(number_of_particles) ::  u_int        !<
-    REAL(wp), DIMENSION(number_of_particles) ::  v_int        !<
-    REAL(wp), DIMENSION(number_of_particles) ::  w_int        !<
-    REAL(wp), DIMENSION(number_of_particles) ::  xv           !<
-    REAL(wp), DIMENSION(number_of_particles) ::  yv           !<
-    REAL(wp), DIMENSION(number_of_particles) ::  zv           !<
-
-    REAL(wp), DIMENSION(number_of_particles, 3) ::  rg !<
+    REAL(wp), DIMENSION(number_of_particles) ::  de_dx_int    !< horizontal TKE gradient along x at particle position
+    REAL(wp), DIMENSION(number_of_particles) ::  de_dy_int    !< horizontal TKE gradient along y at particle position
+    REAL(wp), DIMENSION(number_of_particles) ::  de_dz_int    !< horizontal TKE gradient along z at particle position
+    REAL(wp), DIMENSION(number_of_particles) ::  diss_int     !< dissipation at particle position
+    REAL(wp), DIMENSION(number_of_particles) ::  dt_particle  !< particle time step
+    REAL(wp), DIMENSION(number_of_particles) ::  e_int        !< TKE at particle position
+    REAL(wp), DIMENSION(number_of_particles) ::  fs_int       !< weighting factor for subgrid-scale particle speed
+    REAL(wp), DIMENSION(number_of_particles) ::  u_int        !< u-component of particle speed
+    REAL(wp), DIMENSION(number_of_particles) ::  v_int        !< v-component of particle speed 
+    REAL(wp), DIMENSION(number_of_particles) ::  w_int        !< w-component of particle speed
+    REAL(wp), DIMENSION(number_of_particles) ::  xv           !< x-position
+    REAL(wp), DIMENSION(number_of_particles) ::  yv           !< y-position
+    REAL(wp), DIMENSION(number_of_particles) ::  zv           !< z-position
+
+    REAL(wp), DIMENSION(number_of_particles, 3) ::  rg !< vector of Gaussian distributed random numbers 
 
     CALL cpu_log( log_point_s(44), 'lpm_advec', 'continue' )
@@ -236,4 +244,5 @@
        j = jp + block_offset(nb)%j_off
        k = kp + block_offset(nb)%k_off
+
 
 !
@@ -249,13 +258,16 @@
 !--       First, check if particle is located below first vertical grid level 
 !--       (Prandtl-layer height)
-          IF ( constant_flux_layer  .AND.  particles(n)%z < z_p )  THEN
+          ilog = ( particles(n)%x + 0.5_wp * dx ) * ddx
+          jlog = ( particles(n)%y + 0.5_wp * dy ) * ddy
+
+          IF ( constant_flux_layer .AND. zv(n) - zw(nzb_s_inner(jlog,ilog)) < z_p )  THEN
 !
 !--          Resolved-scale horizontal particle velocity is zero below z0. 
-             IF ( particles(n)%z < z0_av_global )  THEN
+             IF ( zv(n) - zw(nzb_s_inner(jlog,ilog)) < z0_av_global )  THEN
                 u_int(n) = 0.0_wp
              ELSE
 !
 !--             Determine the sublayer. Further used as index.
-                height_p     = ( particles(n)%z - z0_av_global )            &
+                height_p     = ( zv(n) - zw(nzb_s_inner(jlog,ilog)) - z0_av_global )            &
                                      * REAL( number_of_sublayers, KIND=wp ) &
                                      * d_z_p_z0 
@@ -263,9 +275,15 @@
 !--             Calculate LOG(z/z0) for exact particle height. Therefore,   
 !--             interpolate linearly between precalculated logarithm. 
-                log_z_z0_int(n) = log_z_z0(INT(height_p))                      &
+                log_z_z0_int = log_z_z0(INT(height_p))                         &
                                  + ( height_p - INT(height_p) )                &
                                  * ( log_z_z0(INT(height_p)+1)                 &
                                       - log_z_z0(INT(height_p))                &
                                    ) 
+!
+!--             Limit friction velocity. In narrow canyons or holes the 
+!--             friction velocity can become very small, resulting in a too
+!--             large particle speed.
+                us_int   = MAX( 0.5_wp * ( us(jlog,ilog) + us(jlog,ilog-1) ),  &
+                                0.01_wp )  
 !
 !--             Neutral solution is applied for all situations, e.g. also for 
@@ -275,10 +293,7 @@
 !--             as sensitivity studies revealed no significant effect of 
 !--             using the neutral solution also for un/stable situations.
-!--             Calculated left and bottom index on u grid.
-                us_int   = 0.5_wp * ( us(j,i) + us(j,i-1) )  
-
-                u_int(n) = -usws(j,i) / ( us_int * kappa + 1E-10_wp )          & 
-                         * log_z_z0_int(n) - u_gtrans
-
+                u_int(n) = -usws(jlog,ilog) / ( us_int * kappa + 1E-10_wp )          & 
+                            * log_z_z0_int - u_gtrans
+                
              ENDIF
 !
@@ -308,4 +323,5 @@
                            ( u_int_u - u_int_l )
              ENDIF
+
           ENDIF
 
@@ -319,11 +335,35 @@
        DO  n = start_index(nb), end_index(nb)
 
-          IF ( constant_flux_layer  .AND.  particles(n)%z < z_p )  THEN
-
-             IF ( particles(n)%z < z0_av_global )  THEN
+          ilog = ( particles(n)%x + 0.5_wp * dx ) * ddx
+          jlog = ( particles(n)%y + 0.5_wp * dy ) * ddy
+          IF ( constant_flux_layer .AND. zv(n) - zw(nzb_s_inner(jlog,ilog)) < z_p )  THEN
+
+             IF ( zv(n) - zw(nzb_s_inner(jlog,ilog)) < z0_av_global )  THEN
 !
 !--             Resolved-scale horizontal particle velocity is zero below z0. 
                 v_int(n) = 0.0_wp
              ELSE       
+!
+!--             Determine the sublayer. Further used as index. Please note, 
+!--             logarithmus can not be reused from above, as in in case of
+!--             topography particle on u-grid can be above surface-layer height,
+!--             whereas it can be below on v-grid. 
+                height_p     = ( zv(n) - zw(nzb_s_inner(jlog,ilog)) - z0_av_global ) &
+                                  * REAL( number_of_sublayers, KIND=wp )    &
+                                  * d_z_p_z0 
+!
+!--             Calculate LOG(z/z0) for exact particle height. Therefore,   
+!--             interpolate linearly between precalculated logarithm. 
+                log_z_z0_int = log_z_z0(INT(height_p))                         &
+                                 + ( height_p - INT(height_p) )                &
+                                 * ( log_z_z0(INT(height_p)+1)                 &
+                                      - log_z_z0(INT(height_p))                &
+                                   ) 
+!
+!--             Limit friction velocity. In narrow canyons or holes the 
+!--             friction velocity can become very small, resulting in a too
+!--             large particle speed.
+                us_int   = MAX( 0.5_wp * ( us(jlog,ilog) + us(jlog-1,ilog) ), &
+                                0.01_wp )    
 !
 !--             Neutral solution is applied for all situations, e.g. also for 
@@ -333,10 +373,9 @@
 !--             as sensitivity studies revealed no significant effect of 
 !--             using the neutral solution also for un/stable situations.
-!--             Calculated left and bottom index on v grid.
-                us_int   = 0.5_wp * ( us(j,i) + us(j-1,i) )    
-
-                v_int(n) = -vsws(j,i) / ( us_int * kappa + 1E-10_wp )          &
-                         * log_z_z0_int(n) - v_gtrans
-             ENDIF
+                v_int(n) = -vsws(jlog,ilog) / ( us_int * kappa + 1E-10_wp )          &
+                         * log_z_z0_int - v_gtrans
+
+             ENDIF
+
           ELSE
              x  = xv(n) - i * dx
@@ -361,4 +400,5 @@
                                   ( v_int_u - v_int_l )
              ENDIF
+
           ENDIF
 
@@ -367,5 +407,5 @@
        i = ip + block_offset(nb)%i_off
        j = jp + block_offset(nb)%j_off
-       k = kp-1
+       k = kp - 1
 !
 !--    Same procedure for interpolation of the w velocity-component
@@ -535,4 +575,8 @@
                 ENDIF
 
+!
+!--             Set flag for stochastic equation.
+                term_1_2(n) = 1.0_wp
+
              ENDDO
           ENDDO
@@ -541,5 +585,4 @@
 
           DO  n = 1, number_of_particles
-
              i = particles(n)%x * ddx
              j = particles(n)%y * ddy
@@ -575,7 +618,5 @@
                 de_dzi(num_gp) = de_dz(k,j,i)
              ENDIF
-
-             IF ( k > nzb_s_inner(j+1,i)  .OR.  nzb_s_inner(j+1,i) == 0 ) &
-             THEN
+             IF ( k > nzb_s_inner(j+1,i)  .OR.  nzb_s_inner(j+1,i) == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(2) = 1
@@ -603,6 +644,5 @@
              ENDIF
 
-             IF ( k+1 > nzb_s_inner(j+1,i)  .OR.  nzb_s_inner(j+1,i) == 0 ) &
-             THEN
+             IF ( k+1 > nzb_s_inner(j+1,i)  .OR.  nzb_s_inner(j+1,i) == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(4) = 1
@@ -617,6 +657,5 @@
              ENDIF
 
-             IF ( k > nzb_s_inner(j,i+1)  .OR.  nzb_s_inner(j,i+1) == 0 ) &
-             THEN
+             IF ( k > nzb_s_inner(j,i+1)  .OR.  nzb_s_inner(j,i+1) == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(5) = 1
@@ -631,6 +670,5 @@
              ENDIF
 
-             IF ( k > nzb_s_inner(j+1,i+1)  .OR.  nzb_s_inner(j+1,i+1) == 0 ) &
-             THEN
+             IF ( k > nzb_s_inner(j+1,i+1)  .OR.  nzb_s_inner(j+1,i+1) == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(6) = 1
@@ -645,6 +683,5 @@
              ENDIF
 
-             IF ( k+1 > nzb_s_inner(j,i+1)  .OR.  nzb_s_inner(j,i+1) == 0 ) &
-             THEN
+             IF ( k+1 > nzb_s_inner(j,i+1)  .OR.  nzb_s_inner(j,i+1) == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(7) = 1
@@ -659,6 +696,5 @@
              ENDIF
 
-             IF ( k+1 > nzb_s_inner(j+1,i+1)  .OR.  nzb_s_inner(j+1,i+1) == 0)&
-             THEN
+             IF ( k+1 > nzb_s_inner(j+1,i+1)  .OR.  nzb_s_inner(j+1,i+1) == 0)  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(8) = 1
@@ -672,5 +708,4 @@
                 de_dzi(num_gp) = de_dz(k+1,j+1,i+1)
              ENDIF
-
 !
 !--          If all gridpoints are situated outside of a building, then the
@@ -685,9 +720,9 @@
                 dd = ( dx - x )**2 + ( dy - y )**2
                 gg = aa + bb + cc + dd
-
+  
                 e_int_l = ( ( gg - aa ) * e(k,j,i)   + ( gg - bb ) * e(k,j,i+1)   &
                           + ( gg - cc ) * e(k,j+1,i) + ( gg - dd ) * e(k,j+1,i+1) &
                           ) / ( 3.0_wp * gg )
-
+   
                 IF ( k == nzt )  THEN
                    e_int(n) = e_int_l
@@ -699,7 +734,7 @@
                              ) / ( 3.0_wp * gg )
                    e_int(n) = e_int_l + ( zv(n) - zu(k) ) / dz * &
-                                     ( e_int_u - e_int_l )
-                ENDIF
-!
+                                       ( e_int_u - e_int_l )
+                ENDIF
+! 
 !--             Needed to avoid NaN particle velocities (this might not be
 !--             required any more)
@@ -757,5 +792,5 @@
                                    ( gg - dd ) * de_dz(k,j+1,i+1) &
                                  ) / ( 3.0_wp * gg )
-
+ 
                    IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
                       de_dz_int(n) = de_dz_int_l
@@ -778,5 +813,5 @@
                                ( gg - dd ) * diss(k,j+1,i+1) &
                              ) / ( 3.0_wp * gg )
-
+ 
                 IF ( k == nzt )  THEN
                    diss_int(n) = diss_int_l
@@ -790,7 +825,10 @@
                                            ( diss_int_u - diss_int_l )
                 ENDIF
-
+!
+!--             Set flag for stochastic equation.
+                term_1_2(n) = 1.0_wp
+ 
              ELSE
-
+ 
 !
 !--             If wall between gridpoint 1 and gridpoint 5, then
@@ -810,5 +848,5 @@
 
                 IF ( gp_outside_of_building(5) == 1  .AND. &
-                   gp_outside_of_building(1) == 0 )  THEN
+                     gp_outside_of_building(1) == 0 )  THEN
                    num_gp = num_gp + 1
                    location(num_gp,1) = i * dx + 0.5_wp * dx
@@ -893,5 +931,5 @@
                    de_dxi(num_gp) = de_dx(k,j,i)
                    de_dyi(num_gp) = 0.0_wp
-                   de_dzi(num_gp) = de_dz(k,j,i)
+                   de_dzi(num_gp) = de_dz(k,j,i)  
                 ENDIF
 
@@ -1076,5 +1114,5 @@
                 ENDIF
 
-!
+! 
 !--             If wall between gridpoint 6 and gridpoint 8, then
 !--             Neumann boundary condition has to be applied
@@ -1092,21 +1130,25 @@
                    de_dzi(num_gp) = 0.0_wp
                 ENDIF
-
+  
 !
 !--             Carry out the interpolation
                 IF ( num_gp == 1 )  THEN
-!
+! 
 !--                If only one of the gridpoints is situated outside of the
 !--                building, it follows that the values at the particle
 !--                location are the same as the gridpoint values
-                   e_int(n)     = ei(num_gp)
-                   diss_int(n)  = dissi(num_gp)
+                   e_int(n)     = ei(num_gp)    
+                   diss_int(n)  = dissi(num_gp) 
                    de_dx_int(n) = de_dxi(num_gp)
                    de_dy_int(n) = de_dyi(num_gp)
                    de_dz_int(n) = de_dzi(num_gp)
+!
+!--                Set flag for stochastic equation which disables calculation 
+!--                of drift and memory term near topography.
+                   term_1_2(n) = 0.0_wp
                 ELSE IF ( num_gp > 1 )  THEN
-
+ 
                    d_sum = 0.0_wp
-!
+! 
 !--                Evaluation of the distances between the gridpoints
 !--                contributing to the interpolated values, and the particle
@@ -1118,12 +1160,12 @@
                       d_sum        = d_sum + d_gp_pl(agp)
                    ENDDO
-
+ 
 !
 !--                Finally the interpolation can be carried out
                    e_int(n)     = 0.0_wp 
                    diss_int(n)  = 0.0_wp 
-                   de_dx_int(n) = 0.0_wp 
-                   de_dy_int(n) = 0.0_wp 
-                   de_dz_int(n) = 0.0_wp 
+                   de_dx_int(n) = 0.0_wp  
+                   de_dy_int(n) = 0.0_wp  
+                   de_dz_int(n) = 0.0_wp  
                    DO  agp = 1, num_gp
                       e_int(n)     = e_int(n)     + ( d_sum - d_gp_pl(agp) ) * &
@@ -1138,7 +1180,15 @@
                                          de_dzi(agp) / ( (num_gp-1) * d_sum )
                    ENDDO
-
-                ENDIF
-
+ 
+                ENDIF
+                e_int(n)     = MAX( 1E-20_wp, e_int(n)     )
+                diss_int(n)  = MAX( 1E-20_wp, diss_int(n)  )
+                de_dx_int(n) = MAX( 1E-20_wp, de_dx_int(n) )
+                de_dy_int(n) = MAX( 1E-20_wp, de_dy_int(n) ) 
+                de_dz_int(n) = MAX( 1E-20_wp, de_dz_int(n) ) 
+!
+!--             Set flag for stochastic equation which disables calculation 
+!--             of drift and memory term near topography.
+                term_1_2(n) = 0.0_wp
              ENDIF
           ENDDO
@@ -1209,6 +1259,6 @@
 !
 !--       Calculate the Lagrangian timescale according to Weil et al. (2004).
-          lagr_timescale = ( 4.0_wp * e_int(n) ) / &
-                           ( 3.0_wp * fs_int(n) * c_0 * diss_int(n) )
+          lagr_timescale = ( 4.0_wp * e_int(n) + 1E-20_wp ) / &
+                           ( 3.0_wp * fs_int(n) * c_0 * diss_int(n) + 1E-20_wp )
 
 !
@@ -1233,9 +1283,9 @@
 !--          [-5.0*sigma, 5.0*sigma] in order to prevent the SGS velocities
 !--          from becoming unrealistically large.
-             particles(n)%rvar1 = SQRT( 2.0_wp * sgs_wfu_part * e_int(n) ) *   &
+             particles(n)%rvar1 = SQRT( 2.0_wp * sgs_wf_part * e_int(n) + 1E-20_wp ) *   &
                                   ( rg(n,1) - 1.0_wp )
-             particles(n)%rvar2 = SQRT( 2.0_wp * sgs_wfv_part * e_int(n) ) *   &
+             particles(n)%rvar2 = SQRT( 2.0_wp * sgs_wf_part * e_int(n) + 1E-20_wp ) *   &
                                   ( rg(n,2) - 1.0_wp )
-             particles(n)%rvar3 = SQRT( 2.0_wp * sgs_wfw_part * e_int(n) ) *   &
+             particles(n)%rvar3 = SQRT( 2.0_wp * sgs_wf_part * e_int(n) + 1E-20_wp ) *   &
                                   ( rg(n,3) - 1.0_wp )
 
@@ -1267,45 +1317,21 @@
              ENDIF
 
-             particles(n)%rvar1 = particles(n)%rvar1 - fs_int(n) * c_0 *       &
-                           diss_int(n) * particles(n)%rvar1 * dt_particle(n) / &
-                           ( 4.0_wp * sgs_wfu_part * e_int(n) ) +              &
-                           ( 2.0_wp * sgs_wfu_part * de_dt *                   &
-                             particles(n)%rvar1 /                              &
-                             ( 2.0_wp * sgs_wfu_part * e_int(n) ) +            &
-                             de_dx_int(n)                                      &
-                           ) * dt_particle(n) / 2.0_wp          +              &
-                           SQRT( fs_int(n) * c_0 * diss_int(n) ) *             &
-                           ( rg(n,1) - 1.0_wp ) *                              &
-                           SQRT( dt_particle(n) )
-
-             particles(n)%rvar2 = particles(n)%rvar2 - fs_int(n) * c_0 *       &
-                           diss_int(n) * particles(n)%rvar2 * dt_particle(n) / &
-                           ( 4.0_wp * sgs_wfv_part * e_int(n) ) +              &
-                           ( 2.0_wp * sgs_wfv_part * de_dt *                   &
-                             particles(n)%rvar2 /                              &
-                             ( 2.0_wp * sgs_wfv_part * e_int(n) ) +            &
-                             de_dy_int(n)                                      &
-                           ) * dt_particle(n) / 2.0_wp          +              &
-                           SQRT( fs_int(n) * c_0 * diss_int(n) ) *             &
-                           ( rg(n,2) - 1.0_wp ) *                              &
-                           SQRT( dt_particle(n) )
-
-             particles(n)%rvar3 = particles(n)%rvar3 - fs_int(n) * c_0 *       &
-                           diss_int(n) * particles(n)%rvar3 * dt_particle(n) / &
-                           ( 4.0_wp * sgs_wfw_part * e_int(n) ) +              &
-                           ( 2.0_wp * sgs_wfw_part * de_dt *                   &
-                             particles(n)%rvar3 /                              &
-                             ( 2.0_wp * sgs_wfw_part * e_int(n) ) +            &
-                             de_dz_int(n)                                      &
-                           ) * dt_particle(n) / 2.0_wp          +              &
-                           SQRT( fs_int(n) * c_0 * diss_int(n) ) *             &
-                           ( rg(n,3) - 1.0_wp ) *                              &
-                           SQRT( dt_particle(n) )
+             CALL weil_stochastic_eq(particles(n)%rvar1, fs_int(n), e_int(n),  & 
+                                     de_dx_int(n), de_dt, diss_int(n),         &
+                                     dt_particle(n), rg(n,1), term_1_2(n) )
+
+             CALL weil_stochastic_eq(particles(n)%rvar2, fs_int(n), e_int(n),  & 
+                                     de_dy_int(n), de_dt, diss_int(n),         &
+                                     dt_particle(n), rg(n,2), term_1_2(n) )
+
+             CALL weil_stochastic_eq(particles(n)%rvar3, fs_int(n), e_int(n),  & 
+                                     de_dz_int(n), de_dt, diss_int(n),         &
+                                     dt_particle(n), rg(n,3), term_1_2(n) )
 
           ENDIF
+
           u_int(n) = u_int(n) + particles(n)%rvar1
           v_int(n) = v_int(n) + particles(n)%rvar2
           w_int(n) = w_int(n) + particles(n)%rvar3
-
 !
 !--       Store the SGS TKE of the current timelevel which is needed for
